package com.coti.guitools;

import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;


public class AuxButton {
    

    public static void errMess(Component propietario, String mensaje, String titulo) {
        JOptionPane.showMessageDialog(	propietario,
                mensaje,
                titulo,
                JOptionPane.ERROR_MESSAGE);
    }
    

    public static ArrayList<JButton> createButtonList(ArrayList<String>nombres,
            ArrayList<ActionListener>oyentes,
            ArrayList<Integer> eventosDeTecla,
            ArrayList<String> ordenesDeAccion,
            ArrayList<ImageIcon> iconos) {
        ArrayList<JButton> listaB = new ArrayList<JButton>();
        if (null == nombres) {
            errMess(null,"No hay nombres para los botones","AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        JButton temp;
        listaB = new ArrayList<JButton>();
        for(int i=0;i<number;i++) {
            temp = new JButton(nombres.get(i));
            if (null != oyentes)
                temp.addActionListener(oyentes.get(i));
            if (null != eventosDeTecla)
                temp.setMnemonic(eventosDeTecla.get(i));
            if (null != ordenesDeAccion)
                temp.setActionCommand(ordenesDeAccion.get(i));
            if (null != iconos)
                temp.setIcon(iconos.get(i));
            listaB.add(temp);
        }
        return listaB;
    }
    
    public static ArrayList<JButton> createButtonList(ArrayList<String>nombres,
            ArrayList<ActionListener>oyentes) {
        ArrayList<JButton> listaB = new ArrayList<JButton>();
        if (null == nombres) {
            errMess(null,"No hay nombres para los botones","AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        JButton temp;
        listaB = new ArrayList<JButton>();
        for(int i=0;i<number;i++) {
            temp = new JButton(nombres.get(i));
            if (null != oyentes)
                temp.addActionListener(oyentes.get(i));
            listaB.add(temp);
        }
        return listaB;
    }
    
    public static ArrayList<JButton> createButtonList(ArrayList<String>nombres,
            ActionListener oyente) {
        ArrayList<JButton> listaB = new ArrayList<JButton>();
        if (null == nombres) {
            errMess(null,"No hay nombres para los botones","AuxButton - error fatal");
            System.exit(1);
        }
        if (null == oyente) {
            errMess(null,"No oyente for buttons","AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        JButton temp;
        listaB = new ArrayList<JButton>();
        for(int i=0;i<number;i++) {
            temp = new JButton(nombres.get(i));
            temp.addActionListener(oyente);
            listaB.add(temp);
        }
        return listaB;
    }
    

    public static  ArrayList<JRadioButton> createRBList(ArrayList<String> nombres,
            ArrayList<ActionListener> oyentes,
            int selected) {
        if (null == nombres) {
            errMess( null,"No hay nombres para los botones de radio",
                    "AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        ButtonGroup bg = new ButtonGroup();
        JRadioButton temp;
        ArrayList<JRadioButton> listaBr = new ArrayList<JRadioButton>();
        for(int i=0;i<number;i++) {
            temp = new JRadioButton(nombres.get(i));
            if (null != oyentes)
                temp.addActionListener(oyentes.get(i));
            temp.setSelected(selected == i ? true:false);
            listaBr.add(temp);
            bg.add(temp);
        }
        return listaBr;
    }
    

    public static  ArrayList<JRadioButton> createRBList(ArrayList<String> nombres,
            ActionListener oyente,
            int selected) {
        if (null == nombres) {
            errMess( null,"No hay nombres para los botones de radio",
                    "AuxButton - error fatal");
            System.exit(1);
        }
        if (null == oyente) {
            errMess(null,"No hay oyente para los botones de radio","AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        ButtonGroup bg = new ButtonGroup();
        JRadioButton temp;
        ArrayList<JRadioButton> listaBr = new ArrayList<JRadioButton>();
        for(int i=0;i<number;i++) {
            temp = new JRadioButton(nombres.get(i));
            if (null != oyente)
                temp.addActionListener(oyente);
            temp.setSelected(selected == i ? true : false);
            listaBr.add(temp);
            bg.add(temp);
        }
        return listaBr;
    }
    
    public static  ArrayList<JCheckBox> createCBList(ArrayList<String> nombres,
            ArrayList<ActionListener> oyentes,
            ArrayList<Boolean> seleccionados) {
        if (null == nombres) {
            errMess(null, "No hay nombres para las casillas de verificacin",
                    "AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        JCheckBox temp;
        ArrayList<JCheckBox> listaCv = new ArrayList<JCheckBox>();
        for(int i=0;i<number;i++) {
            temp = new JCheckBox(nombres.get(i));
            if (null != oyentes)
                temp.addActionListener(oyentes.get(i));
            if (null != seleccionados)
                temp.setSelected(seleccionados.get(i));
            listaCv.add(temp);
        }
        return listaCv;
    }


    public static  ArrayList<JCheckBox> createCBList(ArrayList<String> nombres,
            ActionListener oyente,
            ArrayList<Boolean> seleccionados) {
        if (null == nombres) {
            errMess(null, "No hay nombres para las casillas de verificacin",
                    "AuxButton - error fatal");
            System.exit(1);
        }
        if (null == oyente) {
            errMess(null,"No hay oyente para las casillas de verificacin","AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        JCheckBox temp;
        ArrayList<JCheckBox> listaCv = new ArrayList<JCheckBox>();
        for(int i=0;i<number;i++) {
            temp = new JCheckBox(nombres.get(i));
            if (null != oyente)
                temp.addActionListener(oyente);
            if (null != seleccionados)
                temp.setSelected(seleccionados.get(i));
            listaCv.add(temp);
        }
        return listaCv;
    }
    
    public static  ArrayList<JCheckBox> createCBList(ArrayList<String> nombres,
            ArrayList<Boolean> seleccionados) {
        if (null == nombres) {
            errMess(null, "No hay nombres para las casillas de verificacin",
                    "AuxButton - error fatal");
            System.exit(1);
        }
        int number = nombres.size();
        JCheckBox temp;
        ArrayList<JCheckBox> listaCv = new ArrayList<JCheckBox>();
        for(int i=0;i<number;i++) {
            temp = new JCheckBox(nombres.get(i));
            if (null != seleccionados)
                temp.setSelected(seleccionados.get(i));
            listaCv.add(temp);
        }
        return listaCv;
    }
    
    
    private static void pws(	SpringLayout d,
            Component comp,
            int posX,
            int posY,
            int width,
            int height) {
        Dimension dim = new Dimension(width, height);
        comp.setPreferredSize(dim);
        comp.setMaximumSize(dim);
        
        SpringLayout.Constraints cons = d.getConstraints(comp);
        cons.setX(Spring.constant(posX));
        cons.setY(Spring.constant(posY));
    }
    
    public static JPanel panelWithButtons(ArrayList<JButton> listaB) {
        JPanel panelB = new JPanel();
        SpringLayout sl = new SpringLayout();
        panelB.setLayout(sl);
        JButton b        = null;
        int posY         = 6;
        int alturaBoton = 0;
        int anchuraBoton = 0;
        FontMetrics fm = null;
        int anchuraMin = 200;
        int alturaMin = 0;
        b = listaB.get(0);
        fm = b.getFontMetrics(b.getFont());
        
        for(int i=0;i<listaB.size();i++) {
            b = listaB.get(i);
            panelB.add(b);
            alturaBoton = b.getHeight() + 20;
            anchuraBoton = fm.stringWidth(b.getText())+50;
            pws(sl,b, 6, posY, anchuraBoton, alturaBoton);
            posY += alturaBoton+10;

            if (anchuraBoton > anchuraMin)
                anchuraMin=anchuraBoton;
        }
        alturaMin = posY + alturaBoton + 5;
        Dimension dim = new Dimension(anchuraMin,alturaMin);
        panelB.setPreferredSize(dim);
        panelB.setSize(dim);
        panelB.setMaximumSize(dim);
        return panelB;
    }
    

    public static JPanel panelWithIconButtons(ArrayList<JButton> listaB) {
        JPanel panelB = new JPanel();
        SpringLayout sl = new SpringLayout();
        panelB.setLayout(sl);
        JButton b        = null;
        int posY         = 6;
        int alturaBoton = 0;
        int anchuraBoton = 0;
        FontMetrics fm = null;
        int anchuraMin = 0;
        int alturaMin = 0;
        b = listaB.get(0);
        fm = b.getFontMetrics(b.getFont());
        
        for(int i=0;i<listaB.size();i++) {
            b = listaB.get(i);
            alturaBoton = b.getIcon().getIconHeight() + 10;
            anchuraBoton = fm.stringWidth(b.getText())+ b.getIcon().getIconWidth();
            if (anchuraBoton > anchuraMin) anchuraMin=anchuraBoton;
        }
        for(int i=0;i<listaB.size();i++) {
            b = listaB.get(i);
            alturaBoton = b.getIcon().getIconHeight() + 10;
            pws(sl,b, 6, posY, anchuraMin+20, alturaBoton);
            posY += alturaBoton+10;
            panelB.add(b);
        }
        alturaMin = posY + alturaBoton + 5;
        Dimension dim = new Dimension(anchuraMin,alturaMin);
        panelB.setPreferredSize(dim);
        panelB.setSize(dim);
        panelB.setMaximumSize(dim);
        return panelB;
    }
    

    public static JPanel panelWithRadioButtons(ArrayList<JRadioButton> listaB) {
        JPanel panelB = new JPanel();
        SpringLayout sl = new SpringLayout();
        panelB.setLayout(sl);
        JRadioButton b        =  null;
        int posY         =     6;
        int alturaBoton =    18;
        int anchuraBoton  =     0;
        FontMetrics fm = null;
        int anchuraMin = 200;
        int alturaMin = 0;
        
        b = listaB.get(0);
        fm = b.getFontMetrics(b.getFont());
        
        for(int i=0;i<listaB.size();i++) {
            b = listaB.get(i);
            
            anchuraBoton = fm.stringWidth(b.getText())+50;
            pws(sl,b, 6, posY, anchuraBoton, alturaBoton);
            posY += alturaBoton+10;
            panelB.add(b);
            if (anchuraBoton > anchuraMin)
                anchuraMin=anchuraBoton;
        }
        alturaMin = posY + alturaBoton + 5;
        Dimension dim = new Dimension(anchuraMin,alturaMin);
        panelB.setPreferredSize(dim);
        panelB.setSize(dim);
        panelB.setMaximumSize(dim);
        return panelB;
    }
    

    public static JPanel panelWithCheckBoxes(ArrayList<JCheckBox> listaB) {
        JPanel panelB = new JPanel();
        SpringLayout sl = new SpringLayout();
        panelB.setLayout(sl);
        JCheckBox b        =  null;
        int posY         =     6;
        int alturaBoton =    18;
        int anchuraBoton  =     0;
        FontMetrics fm = null;
        int anchuraMin = 200;
        int alturaMin = 0;
        b = listaB.get(0);
        fm = b.getFontMetrics(b.getFont());
        
        for(int i=0;i<listaB.size();i++) {
            b = listaB.get(i);
            anchuraBoton = fm.stringWidth(b.getText())+50;
            pws(sl,b, 6, posY, anchuraBoton, alturaBoton);
            posY += alturaBoton+10;
            panelB.add(b);
            if (anchuraBoton > anchuraMin)
                anchuraMin=anchuraBoton;
        }
        alturaMin = posY + alturaBoton + 5;
        Dimension dim = new Dimension(anchuraMin,alturaMin);
        panelB.setPreferredSize(dim);
        panelB.setSize(dim);
        panelB.setMaximumSize(dim);
        return panelB;
    }
    

    public static boolean[] getSelected(ArrayList<JCheckBox> cb) {
        int dim = cb.size();
        if (0 == dim) {
            errMess(null, "No hay casillas de verificacin en lalista","Lista vaca");
            return null;
        }
        boolean[] r = new boolean[cb.size()];
        for(int i=0;i<dim;i++)
            r[i] = cb.get(i).isSelected();
        return r;
    }
    

    public static int getSelected(ArrayList<JRadioButton> rb) {
        int selectedButton = -1;
        int dim = rb.size();
        if (0 == dim) {
            errMess(null, "No hay botones de radio en la lista","Lista vaca");
            return selectedButton;
        }
        for(int i=0;i<dim;i++)
            if(rb.get(i).isSelected()) {
            selectedButton = i;
            break;
            }
        return selectedButton;
    }
}
