package com.coti.guitools;

import javax.swing.*;
import java.awt.event.*;

public class AuxMenu {
    
    public static  JMenuItem makeOpt(String name, ActionListener action){
        JMenuItem jmi = null;
        if (null == name || null == action) {
            JOptionPane.showMessageDialog(	null,
                    "JMenuItem: null name or action not valid.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        } else {
            jmi = new JMenuItem(name);
            jmi.addActionListener(action);
        }
        return jmi;
    }
    
    public static  JMenuItem makeOpt(String name, ActionListener action, String command){
        JMenuItem jmi = null;
        if (null == action || null == command) {
            JOptionPane.showMessageDialog(	null,
                    "JMenuItem: null action or command.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        } else {
            jmi = new JMenuItem(name);
            jmi.setActionCommand(command);
            jmi.addActionListener(action);
        }
        return jmi;
    }
    
    public static JMenuItem[] makeOptList(String[] names, ActionListener listener, String[] ac){
        int numberOfItems = 0;
        JMenuItem[] menuItems = null;
        if (null == names || null == listener || null == ac) {
            JOptionPane.showMessageDialog(	null,
                    "JMenuItem: null names, action or commands.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        } else {
            numberOfItems = names.length;
            menuItems = new JMenuItem[numberOfItems];
            for(int i=0;i<numberOfItems;i++)
                menuItems[i] = makeOpt(names[i],listener,ac[i]);
        }
        return menuItems;
    }
    public static JMenuItem[] makeCtrlOptList(String[] names, ActionListener listener, String[] ac, int[] vKeys){
        int numberOfItems = 0;
        JMenuItem[] menuItems = null;
        if (null == names || null == listener || null == ac) {
            JOptionPane.showMessageDialog(	null,
                    "JMenuItem: null names, action or commands.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        } else {
            numberOfItems = names.length;
            menuItems = new JMenuItem[numberOfItems];
            for(int i=0;i<numberOfItems;i++) {
                menuItems[i] = ctrlOpt(names[i],listener,vKeys[i]);               
                menuItems[i].setActionCommand(ac[i]);
                }
        }
        return menuItems;
    }
    public static  JMenuItem makeOpt(String name, ActionListener action, int vKey, int mask){
        JMenuItem jmi = null;
        if (null == action) {
            JOptionPane.showMessageDialog(	null,
                    "JMenuItem: null action not valid.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        } else {
            jmi = new JMenuItem(name);
            jmi.addActionListener(action);
            KeyStroke k = KeyStroke.getKeyStroke(vKey,mask);
            jmi.setAccelerator(k);
        }
        return jmi;
    }
    
    public static  JMenuItem ctrlOpt(String name, ActionListener action, int vKey){
        JMenuItem jmi = null;
        if (null == action) {
            JOptionPane.showMessageDialog(	null,
                    "JMenuItem: null action not valid.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        } else {
            jmi = new JMenuItem(name);
            jmi.addActionListener(action);
            KeyStroke k = KeyStroke.getKeyStroke(vKey,InputEvent.CTRL_MASK);
            jmi.setAccelerator(k);
        }
        return jmi;
    }
    
    public static  JMenuItem metaOpt(String name, ActionListener action, int vKey){
        JMenuItem jmi = null;
        if (null == action) {
            JOptionPane.showMessageDialog(	null,
                    "JMenuItem: null action not valid.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        } else {
            jmi = new JMenuItem(name);
            jmi.addActionListener(action);
            KeyStroke k = KeyStroke.getKeyStroke(vKey,InputEvent.META_MASK);
            jmi.setAccelerator(k);
        }
        return jmi;
    }
    
    public static JMenu makeMenu(String nameOfMenu, JMenuItem[] listOfJMenuItems){
        if (null == nameOfMenu || null == listOfJMenuItems) {
            JOptionPane.showMessageDialog(	null,
                    "JMenu: Null name or list of items.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(2);
        }
        JMenu jm = new JMenu(nameOfMenu);
        for(JMenuItem option : listOfJMenuItems) {
            jm.add(option);
        }
        return jm;
    }
    
    public static JMenuBar makeMenuBar(JMenu[] listOfJMenus){
        if (null == listOfJMenus) {
            JOptionPane.showMessageDialog(	null,
                    "JMenubar: Null list of menus.",
                    "Fatal error...exiting.",
                    JOptionPane.ERROR_MESSAGE);
            System.exit(3);
        }
        JMenuBar jmb = new JMenuBar();
        for(JMenu menu : listOfJMenus) {
            jmb.add(menu);
        }
        return jmb;
        
    }
}
